import wx, lbc
import sqlite3, sys, time, os
#from accessible_output import speech
#spk = speech.Speaker()
dlg = None
lbItems = None
lItems = []
cn = None
cur = None
from dbStructure import createDB
from aClasses import aProject, aSubProject

def padInt(iVal, iLen=2):
	sOut = str(iVal)
	if len(sOut) < iLen:
		for I in range(iLen - len(sOut)):
			sOut = "0" + sOut
	return sOut
#end of padInt

def getSubProjects(ID):
	global cn, cur
	lSubProjects = []
	lRows = cur.execute("select Id, ProjectID, sName, sDate, sTime, sDescription from tblSubProjects where ProjectID = " + str(ID) + " order by Id;").fetchall()
	if len(lRows) > 0:
		for eachRow in lRows:
			nSubProject = aSubProject(eachRow[1], eachRow[0], eachRow[2].encode(), eachRow[5].encode())
			nSubProject.sDate = eachRow[3].encode()
			nSubProject.sTime = eachRow[4].encode()
			lSubProjects.append(nSubProject)
	return lSubProjects
#end of getSubProjects

def initDB():
	global cn, cur, dlg, lbItems#, spk
	#spk.output("initDB")
	blReturn = True
	try:
		cn = sqlite3.connect("activities")
		cur = cn.cursor()
		try:
			cur.execute("select Id, sName, iRanking, sDate, sTime, sDescription from tblProjects order by iRanking, sDate;")
		except:
			#empty db
			#spk.output("empty DB", interrupt=True)
			blCreated = createDB(cn)
			if blCreated:
				cur.execute("select Id, sName, iRanking, sDate, sTime, sDescription from tblProjects order by iRanking, sDate;")
		cRows = cur.fetchall()
		for eachRow in cRows:
			sShow = str(eachRow)
			nProj = aProject(int(eachRow[0]), eachRow[1].encode(), int(eachRow[2]), eachRow[5].encode())
			nProj.sDate = eachRow[3].encode()
			nProj.sTime = eachRow[4].encode()
			sOut = nProj.sName + " " + nProj.sDate + " " + nProj.sTime
			lbItems.Append(sOut)
			#add subProjects to projects
			lSubProjects = getSubProjects(nProj.ID)
			nProj.lSubProjects = lSubProjects
			lItems.append(nProj)
	except:
		lbc.DialogShow(title="issue", message=str(sys.exc_info()[1]))
		blReturn = False
	return blReturn
#end of initDB

def addItem():
	global cn, cur, lbItems, lItems, dlg
	lProj = lbc.DialogMultiInput(title="Add item", labels=["Name", "Description"], values=["", ""])
	if len(lProj[0]) > 0:
		nProj = aProject(0, lProj[0].encode().strip(), 3, lProj[1].encode().strip())
		sOut = nProj.sName + " " + nProj.sDate + " " + nProj.sTime
		lbItems.Append(sOut)
		lbItems.SetFocus()
		lbItems.Select(len(lItems) - 1)
		#tblProjects (Id, sName, iRanking, sDate, sTime, sDescription)
		sSQL = "insert into tblProjects values (?, ?, ?, ?, ?, ?);"
		vals = (None, nProj.sName, nProj.iRanking, nProj.sDate, nProj.sTime, nProj.sDescription, )
		cur.execute(sSQL, vals)
		nProj.ID = cur.lastrowid
		cn.commit()
		lItems.append(nProj)
		cn.commit()
#end of addItem

def addSubItem(dlgE):
	global cn, cur, lItems
	#tblSubProjects (Id, ProjectID, sName, sDate, sTime, sDescription)
	lSubProj = lbc.DialogMultiInput(title="Add sub item", labels=["Name", "Description"], values=["", ""])
	nSProj = aSubProject(dlgE.Project.ID, 0, lSubProj[0], lSubProj[1])
	sSQL = "insert into tblSubProjects values (?, ?, ?, ?, ?, ?);"
	vals = (None, dlgE.Project.ID, nSProj.sName, nSProj.sDate, nSProj.sTime, nSProj.sDescription)
	cur.execute(sSQL, vals)
	nSProj.ID = cur.lastrowid
	#tblActions (Id, pID, spID, sName, sDescription, sDate, sTime, sLength, sType)
	sSQL = "insert into tblActions values (?, ?, ?, ?, ?, ?, ?, ?, ?);"
	vals = (None, dlgE.Project.ID, nSProj.ID, "Initiated", "", nSProj.sDate, nSProj.sTime, 0, "general")
	cur.execute(sSQL, vals)
	cn.commit()
	dlgE.Project.lSubProjects.append(nSProj)
	dlgE.Controls["lbSubProjects"].Append(nSProj.sName)
#end of addSubItem

def OnEventAction(dlgA, event, name):
	global cn, cur
	if lbc.IsCloseEvent(event):
		event.Skip()
	elif lbc.IsClickEvent(event) and name == "Button_Undo":
		dlgA.Close()
	elif lbc.IsClickEvent(event) and name == "Button_Save" and len(dlgA.Controls["txtSName"].Value) > 0:
		sLength = ""
		if dlgA.Controls["lbLength"].GetSelection() == (len(dlgA.Controls["lbLength"].GetItems()) - 1) or dlgA.Controls["lbLength"].GetSelection() == -1:
			sLength = lbc.DialogInput(title="Enter custom length", label="Length:", value="")
		else:
			sLength = str(dlgA.Controls["lbLength"].GetItems()[dlgA.Controls["lbLength"].GetSelection()])
		sType = dlgA.Controls["lbTypes"].GetStringSelection()
		if sType == "" or sType == "None": sType = "general"
		#tblActions (Id, pID, spID, sName, sDescription, sDate, sTime, sLength, sType)
		sSQL = "insert into tblActions values (?, ?, ?, ?, ?, ?, ?, ?, ?);"
		tNow = time.localtime()
		sDate = str(tNow.tm_year) + "/" + padInt(tNow.tm_mon) + "/" + padInt(tNow.tm_mday)
		sTime = padInt(tNow.tm_hour) + ":" + padInt(tNow.tm_min)
		vals = (None, dlgA.pID, dlgA.spID, str(dlgA.Controls["txtSName"].Value), str(dlgA.Controls["txtSDescription"].Value), sDate, sTime, sLength)
		vals += (sType, )
		cn.execute(sSQL, vals)
		cn.commit()
		dlgA.Close()
#end of OnEventAction

def addAction(dlgE, subProject):
	global cn, cur, lItems
	dlgA = lbc.Dialog(title="Add activity entry")
	dlgA.pID = subProject.pID
	dlgA.spID = subProject.ID
	dlgA.AddTextCtrl(name="txtSName", label="Activity &Name:", value="")
	dlgA.AddTextCtrl(name="txtSDescription", label="&Description:", value="")
	lLength = ["0", "0.5", "1", "2", "3", "4", "5", "custom"]
	lbLength = dlgA.AddListBox(name="lbLength", label="Time spent (hours):", names=lLength, values=lLength)
	lbLength.SetSelection(0)
	lTypes = ["general", "design", "planning", "infrastructure", "maintenance"]
	lbTypes = dlgA.AddListBox(name="lbTypes", label="&Type of activity:", names=lTypes, values=lTypes)
	lbTypes.Select(0)
	dlgA.Complete(buttons=["Save", "Undo"], handler=OnEventAction)
#end of addAction

def populateEditDetails(dlgE):
	global cn, cur, lbItems, lItems
	sDetails = "Item:-\n" + dlgE.Project.sName + "\nCreated:-\n" + dlgE.Project.sDate + " " + dlgE.Project.sTime
	dlgE.Controls["txtDetails"].Value = sDetails
	#tblActions (Id, pID, spID, sName, sDescription, sDate, sTime, sLength, sType)
	sSQL = "select tblSubProjects.sName as spName, tblActions.sName, tblActions.sDescription, tblActions.sDate, tblActions.sTime, "
	sSQL += "tblActions.sLength, tblActions.sType from tblSubProjects left join tblActions on tblSubProjects.Id = tblActions.spID where tblSubProjects.ProjectID = "
	sSQL += str(dlgE.Project.ID) + " order by tblActions.Id desc;"
	lActions = cur.execute(sSQL).fetchall()
	if len(lActions) > 0:
		dlgE.Controls["txtDetails"].Value += "\n---activities---\n"
		for eachAct in lActions:
			#spName, sName, sDescription, sDate, sTime, sLength
			sAction = str(eachAct[0]) + "-" + str(eachAct[1]) + "-" + str(eachAct[3]) + " " + str(eachAct[4]) + "-"
			if str(eachAct[5]) in ("0", "0.5", "1", "2", "3", "4", "5"):
				sAction += str(eachAct[5]) + " hrs"
			else:
				sAction += str(eachAct[5])
			sAction += "\n"
			dlgE.Controls["txtDetails"].Value += sAction
#end of populateEditDetails

def OnEventEdit(dlgE, event, name):
	global cn, cur, lItems, lbItems#, spk
	if lbc.IsInitEvent(event):
		populateEditDetails(dlgE)
		if len(dlgE.Project.lSubProjects) > 0:
			for eachSub in dlgE.Project.lSubProjects:
				dlgE.Controls["lbSubProjects"].Append(eachSub.sName)
	elif lbc.IsCloseEvent(event):
		event.Skip()
	elif lbc.IsClickEvent(event) and name == "Button_Close":
		dlgE.Close()
	elif lbc.IsClickEvent(event) and name == "btnEdit":
		lProj = lbc.DialogMultiInput(title="Edit item", labels=["Name", "Description"], values=[dlgE.Project.sName, dlgE.Project.sDescription])
		if len(lProj) > 0:
			if len(lProj[0]) > 0:
				iIndex = lbItems.GetSelection()
				nItems = []
				dlgE.Project.sName = lProj[0]
				dlgE.Project.sDescription = lProj[1]
				for eachProj in lItems:
					sOut = eachProj.sName + " " + eachProj.sDate + " " + eachProj.sTime
					nItems.append(sOut)
				lbItems.SetItems(nItems)
				lbItems.SetSelection(iIndex)
				sSQL = "update tblProjects set sName = '" + lProj[0] + "', sDescription = '" + lProj[1] + "' where Id = " + str(dlgE.Project.ID) + ";"
				cn.execute(sSQL)
				cn.commit()
	elif lbc.IsClickEvent(event) and name == "btnAddSub":
		addSubItem(dlgE)
	elif lbc.IsClickEvent(event) and name == "btnRemoveSub" and dlgE.Controls["lbSubProjects"].GetSelection() > -1:
		sSubName = dlgE.Controls["lbSubProjects"].GetItems()[dlgE.Controls["lbSubProjects"].GetSelection()]
		if lbc.DialogConfirm(title="Are you sure?", message="Do you really want to remove '" + sSubName + "' sub-item?", value="Y") == "Y":
			sSQL = "delete from tblActions where spID = " + str(dlgE.Project.lSubProjects[dlgE.Controls["lbSubProjects"].GetSelection()].ID) + ";"
			cn.execute(sSQL)
			sSQL = "delete from tblSubProjects where Id = " + str(dlgE.Project.lSubProjects[dlgE.Controls["lbSubProjects"].GetSelection()].ID) + ";"
			cn.execute(sSQL)
			cn.commit()
			iIndex = dlgE.Controls["lbSubProjects"].GetSelection()
			lNSubItems = dlgE.Controls["lbSubProjects"].GetItems()
			lNSubItems.remove(lNSubItems[iIndex])
			dlgE.Controls["lbSubProjects"].SetItems(lNSubItems)
			dlgE.Project.lSubProjects.remove(dlgE.Project.lSubProjects[iIndex])
			#dlgE.Controls["lbSubProjects"].Refresh()
	elif lbc.IsClickEvent(event) and name == "btnEditSub" and dlgE.Controls["lbSubProjects"].GetSelection() > -1:
		iIndex = dlgE.Controls["lbSubProjects"].GetSelection()
		subProj = dlgE.Project.lSubProjects[iIndex]
		lProj = lbc.DialogMultiInput(title="Edit sub-item", labels=["Name", "Description"], values=[subProj.sName, subProj.sDescription])
		if len(lProj) > 0:
			if len(lProj[0]) > 0:
				dlgE.Project.lSubProjects[iIndex].sName = str(lProj[0]).encode()
				dlgE.Project.lSubProjects[iIndex].sDescription = str(lProj[1]).encode()
				sSQL = "update tblSubProjects set sName = '" + str(lProj[0]).encode() + "', sDescription = '" + str(lProj[1]).encode() + "' where Id = "
				sSQL += str(dlgE.Project.lSubProjects[iIndex].ID) + ";"
				cn.execute(sSQL)
				cn.commit()
				lSubItems = dlgE.Controls["lbSubProjects"].GetItems()
				lSubItems[iIndex] = dlgE.Project.lSubProjects[iIndex].sName
				dlgE.Controls["lbSubProjects"].SetItems(lSubItems)
				dlgE.Refresh()
				dlgE.Controls["lbSubProjects"].SetSelection(iIndex)
	elif lbc.IsClickEvent(event) and name == "btnAddAction":
		addAction(dlgE, dlgE.Project.lSubProjects[dlgE.Controls["lbSubProjects"].GetSelection()])
		populateEditDetails(dlgE)
#end of OnEventEdit

def editItem(project):
	global cn, cur, lItems, dlg, lbItems#, spk
	dlgE = lbc.Dialog(title="editProjectItem")
	dlgE.Project = project
	dlgE.AddMemo(name="txtDetails", label="&Details", value="", readonly=True)
	dlgE.AddListBox(name="lbSubProjects", label="&Sub-items", names=[], values=[])
	dlgE.AddButtonBand()
	dlgE.AddButton(name="btnEdit", label="&Edit project")
	dlgE.AddButton(name="btnAddSub", label="&Add sub-item")
	dlgE.AddButton(name="btnEditSub", label="Edid sub-&item")
	dlgE.AddButton(name="btnRemoveSub", label="&Remove sub-item")
	dlgE.AddButton(name="btnAddAction", label="Add a&ctivity")
	dlgE.Complete(buttons=["Close"], handler=OnEventEdit)
#end of editItem

def removeItem(iIndex):
	global lbItems, lItems, cn, cur#, spk
	if iIndex != -1:
		ID = lItems[iIndex].ID
		sID = str(ID)
		sSQL = "delete from tblActions where pID = " + sID + ";"
		cn.execute(sSQL)
		sSQL = "delete from tblSubProjects where ProjectID = " + sID + ";"
		cn.execute(sSQL)
		sSQL = "delete from tblProjects where Id = " + sID + ";"
		cn.execute(sSQL)
		cn.commit()
		lItems.remove(lItems[iIndex])
		lbNItems = lbItems.Items
		lbNItems.remove(lbItems.Items[iIndex])
		lbItems.SetItems(lbNItems)
#end of removeItem

def addHours(sHours):
	fOut = 0.0
	sIn = str(sHours).encode()
	try:
		fOut += float(sIn)
	except:
		fOut += 0.0
	return fOut
#end of addHours

def reportDateEvents(dlg, event, name):
	if lbc.IsCloseEvent(event):
		event.Skip()
	elif lbc.IsClickEvent(event) and name == "Button_Show":
		sOut = str(dlg.Controls["lbSYears"].GetStringSelection())
		sOut += "/" + str(dlg.Controls["lbSMonths"].GetStringSelection())
		dlg.startDate = sOut
		sOut = str(dlg.Controls["lbEYears"].GetStringSelection())
		sOut += "/" + str(dlg.Controls["lbEMonths"].GetStringSelection())
		dlg.endDate = sOut
		sType = str(dlg.Controls["lbTypes"].GetStringSelection())
		dlg.sType = sType
		dlg.Close()
#end of reportDateEvents

def reportDates():
	iYear = int(time.localtime().tm_year)
	iMonth = int(time.localtime().tm_mon)
	lYears = range(iYear-2, iYear + 1)
	lYears[0] = str(lYears[0]); lYears[1] = str(lYears[1]); lYears[2] = str(lYears[2]);
	lMonths = ["01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11", "12"]
	dlgR = lbc.Dialog(title="Choose reporting options")
	lbSYears = dlgR.AddListBox(name="lbSYears", label="Starting year:", names=lYears, values=lYears)
	lbSYears.Select(2)
	lbSMonths = dlgR.AddListBox(name="lbSMonths", label="Starting month:", names=lMonths, values=lMonths)
	lbSMonths.Select(iMonth - 1)
	lbEYears = dlgR.AddListBox(name="lbEYears", label="Ending year:", names=lYears, values=lYears)
	lbEYears.Select(2)
	lbEMonths = dlgR.AddListBox(name="lbEMonths", label="Ending month:", names=lMonths, values=lMonths)
	lbEMonths.Select(iMonth - 1)
	lTypes = ["all", "general", "design", "planning", "infrastructure", "maintenance"]
	lbTypes = dlgR.AddListBox(name="lbTypes", label="Type of activity:", names=lTypes, values=lTypes)
	lbTypes.Select(0)
	dlgR.Complete(buttons=["Show", "Undo"], handler=reportDateEvents)
	lRet = [dlgR.startDate, dlgR.endDate, dlgR.sType]
	return lRet
#end of reportDates

def getDateStringList(sSDate, sEDate):
	lOut = []
	iSYear = int(sSDate.split("/")[0])
	iEYear = int(sEDate.split("/")[0])
	iSMonth = int(sSDate.split("/")[1])
	iEMonth = int(sEDate.split("/")[1])
	if iSYear == iEYear:
		for iMonth in range(iSMonth, (iEMonth + 1)):
			lOut.append(str(iSYear) + "/" + padInt(iMonth))
	else:
		#sYear months
		for iMonth in range(iSMonth, 13):
			lOut.append(str(iSYear) + "/" + padInt(iMonth))
		iYear = iSYear + 1
		if iYear < iEYear:
			#middle year
			for iMonth in range(1, 13):
				lOut.append(str(iYear) + "/" + padInt(iMonth))
		#final year
		for iMonth in range(1, (iEMonth + 1)):
			lOut.append(str(iEYear) + "/" + padInt(iMonth))
	return lOut
#end of getDateStringList

def subProjectData(sID, sType, sASQL, fPTotal, fTotal):
	global cn, cur, spk
	sSQL = "select tblSubProjects.sName as sSPName, tblActions.sName, tblActions.sDescription, tblActions.sDate, "
	sSQL += "tblActions.sLength, tblActions.sType from tblSubProjects "
	sSQL += "left join tblActions on tblSubProjects.Id = tblActions.spID "
	sSQL += "where tblSubProjects.ProjectID = " + sID + " and ("
	sSQL += sASQL + ")"
	if sType != "all":
		sSQL += " and tblActions.sType = '" + sType + "'"
	sSQL += " order by tblActions.Id;"
	cData = cur.execute(sSQL).fetchall()
	lData = []
	iRow = -1
	for eachRow in cData:
		iRow += 1
		lData.append([])
		fHours = addHours(eachRow[4])
		fPTotal += fHours
		fTotal += fHours
		for eachColumn in eachRow:
			lData[iRow].append(str(eachColumn).encode())
	lData.append(["Total hours for project: "+ str(fPTotal)])
	return (lData, fHours)
#end of subProjectData

def reporting():
	global cn, cur, lItems, spk
	lDates = reportDates()
	sSDate = lDates[0]
	sEDate = lDates[1]
	lQDates = []
	if sSDate != sEDate:
		iSYear = int(sSDate.split("/")[0])
		iEYear = int(sEDate.split("/")[0])
		if iSYear > iEYear:
			iTYear = iSYear
			iSYear = iEYear
			iEYear = iTYear
		iSMonth = int(sSDate.split("/")[1])
		iEMonth = int(sEDate.split("/")[1])
		if iSYear == iEYear and iSMonth > iEMonth:
			iTMonth = iSMonth
			iSMonth = iEMonth
			iEMonth = iTMonth
		sSDate = str(iSYear) + "/" + padInt(iSMonth)
		sEDate = str(iEYear) + "/" + padInt(iEMonth)
		lQDates = getDateStringList(sSDate, sEDate)
	else:
		lQDates = [sSDate]
	sType = lDates[2]
	if sType == "None" or sType == "": sType = "all"
	from htmlReporting import aReport
	myReport = aReport(sTitle="Time taken")
	fTotal = 0.0
	#lbc.DialogShow(title="fTotal", message=str(fTotal))
	sSQL = "select distinct Id, sName from tblProjects where Id in (select pID from tblActions where"
	sASQL = ""
	for eachDate in lQDates:
		sASQL += " tblActions.sDate like '" + eachDate + "%' or "
	sASQL = sASQL[:len(sASQL) - 4]
	sSQL = sSQL + sASQL + ");"
	cIDs = cur.execute(sSQL).fetchall()
	lMyHeaders = ["subProjectName", "activity", "description", "date", "timeLength", "Type of activity"]
	for eachID in cIDs:
		fPTotal = 0.0
		sID = str(eachID[0]).encode()
		#spk.output("pID " + sID)
		sHeading = "Project: " + str(eachID[1]).encode()
		(lData, fHours) = subProjectData(sID, sType, sASQL, fPTotal, fTotal)
		fPTotal += fHours
		fTotal += fHours
		#lbc.DialogShow(title="lData", message=str(lData))
		#addTable(self, sTitle, sHeading = "", lHeaders = [], lContent = [], sTHStyle="", sTRStyle="", sTDStyle="", sWidth="")
		myReport.addTable(sTitle=sID, sHeading=sHeading, lHeaders=lMyHeaders, lContent=lData)
	myReport.addTextBlock(sHeading="Total time for " + sSDate + " - " + sEDate + ": " + str(fTotal) + " hours")
	try:
		if os.path.exists("output/zTemp.htm"): os.unlink("output/zTemp.htm")
		fOut = open("output/zTemp.htm", "w")
		fOut.write(myReport.mergeContent())
		fOut.close()
		os.system("showReport.bat zTemp.htm")
		time.sleep(1.0)
		#os.unlink("output/zTemp.htm")
	except:
		lbc.DialogShow(title="issue", message=str(sys.exc_info()[1]))
	#end of reporting

def OnEvent(dlg, event, name):
	global cn, cur, lbItems
	if lbc.IsInitEvent(event):
		blWorked = initDB()
		if blWorked == False:
			sys.exit()
		if len(lbItems.Items) > 0:
			lbItems.Select(0)
	elif lbc.IsCloseEvent(event):
		if lbc.DialogConfirm(title="Do you want to exit?", message="Are you finished here for now...?", value="Y") == "Y":
			try:
				cur.close()
				cn.close()
			except:
				pass
			event.Skip()
		else:
			event.Veto()
	elif lbc.IsClickEvent(event) and name == "Button_XIt":
		dlg.Close()
	elif lbc.IsClickEvent(event) and name == "btnAdd":
		addItem()
	elif lbc.IsClickEvent(event) and name == "btnEdit" and lbItems.GetSelection() != -1:
		editItem(lItems[lbItems.GetSelection()])
	elif lbc.IsClickEvent(event) and name == "btnRemove" and lbItems.GetSelection() != -1:
		if lbc.DialogConfirm(title="Are you sure?", message="Do you want to remove item and all history?", value="Y") == "Y":
			removeItem(lbItems.GetSelection())
	elif lbc.IsClickEvent(event) and name == "btnReport":
		reporting()
#end of OnEvent

#main code
app = lbc.App()
dlg = lbc.Dialog(title="timePlanning")
lbItems = dlg.AddListBox(name="lbItems", label="A&ctivities-Projects")
dlg.AddButtonBand()
dlg.AddButton(name="btnAdd", label="&Add new item")
dlg.AddButton(name="btnEdit", label="&Edit-review item")
#dlg.AddButton(name="btnUp", label="Move &up")
#dlg.AddButton(name="btnDown", label="Move &down")
dlg.AddButton(name="btnRemove", label="&Remove item")
dlg.AddButton(name="btnReport", label="Re&porting")
dlg.Complete(buttons=["XIt"], handler=OnEvent)
app.Exit()
